package cn.com.qmth.examcloud.service.examwork.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import cn.com.qmth.examcloud.service.examwork.entity.SpecificExam;

public interface SpecificExamRepo extends JpaRepository<SpecificExam, Long>, QueryByExampleExecutor<SpecificExam> {

	@Query(value = "select * from ecs_exam_specific_exam t where t.exam_id=?1 order by id desc limit ?2,?3", nativeQuery = true)
	List<SpecificExam> findByExamId(@Param("examId") Long examId, @Param("curPage") Integer curPage,
			@Param("pageSize") Integer pageSize);

	@Query(value = "select x.* from ecs_exam_specific_exam x,ecs_exam_specific_exam_course  y where x.id=y.specific_exam_id and y.course_id=?1", nativeQuery = true)
	List<SpecificExam> queryCourseGroupsByCourseId(@Param("courseId") Long courseId);

}
