package cn.com.qmth.examcloud.service.examwork.service.rpc;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.common.dto.core.Course;
import cn.com.qmth.examcloud.common.util.GsonUtil;
import cn.com.qmth.examcloud.service.examwork.service.rpc.client.CourseClient;
import java.util.List;

/**
 * 
 * @author ting.yin
 * @date 2017年1月14日
 */
@Service
public class CourseService {

	@Autowired
	CourseClient courseClient;

	public Course findByOrgIdAndCode(Long orgId,String code) {
		String json = courseClient.findByOrgIdAndCode(orgId,code);
		Course domain = GsonUtil.getInstanceByJson(json, Course.class);
		return domain;
	}

	public List<Course> findByOrgId(Long orgId) {
		String json = courseClient.findByOrgId(orgId);
		List<Course> courseList = GsonUtil.jsonToArrayList(json, Course.class);
		return courseList;
	}

}
